## `FixedSizeArrays.jl`

[![docs stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliaarrays.github.io/FixedSizeArrays.jl/stable)
[![docs dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliaarrays.github.io/FixedSizeArrays.jl/dev)
[![Aqua QA](https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg)](https://github.com/JuliaTesting/Aqua.jl)
[![Build Status](https://github.com/JuliaArrays/FixedSizeArrays.jl/actions/workflows/UnitTests.yml/badge.svg?branch=main)](https://github.com/JuliaArrays/FixedSizeArrays.jl/actions/workflows/UnitTests.yml?query=branch%3Amain)
[![Coverage](https://codecov.io/gh/JuliaArrays/FixedSizeArrays.jl/branch/main/graph/badge.svg)](https://codecov.io/gh/JuliaArrays/FixedSizeArrays.jl)
[![PkgEval](https://JuliaCI.github.io/NanosoldierReports/pkgeval_badges/F/FixedSizeArrays.svg)](https://JuliaCI.github.io/NanosoldierReports/pkgeval_badges/F/FixedSizeArrays.html)

[`FixedSizeArrays.jl`](https://github.com/JuliaArrays/FixedSizeArrays.jl) is a package for the [Julia programming language](https://julialang.org/) which implements mutable fixed-size arrays (`FixedSizeArray`), which means the length of the array can not change after construction and is amenable to be [constant-propagated](https://en.wikipedia.org/wiki/Constant_folding) at compile-time when possible.

FixedSizeArrays supports the [standard array interfaces](https://docs.julialang.org/en/v1/manual/interfaces/#man-interface-array), so things like broadcasting, matrix multiplication, other linear algebra operations, `similar`, `copyto!` or `map` should just work.

Find more in the manual:

* [documentation of latest stable version](https://juliaarrays.github.io/FixedSizeArrays.jl/stable)
* [documentation of in-development version](https://juliaarrays.github.io/FixedSizeArrays.jl/dev)

"""
    BoundsErrorLight <: Exception

Like `BoundsError`, but doesn't store the array, to prevent clashing with escape analysis.

Stores the type of the array and the shape instead.
"""
struct BoundsErrorLight <: Exception
    type_of_array::DataType
    shape::Tuple{Vararg{Int}}
    index::Int
end

function Base.showerror(io::IO, ex::BoundsErrorLight)
    typ = ex.type_of_array
    shp = ex.shape
    ind = ex.index
    print(io, "BoundsErrorLight: attempt to access array of type ")
    show(io, typ)
    print(io, " and shape ")
    show(io, shp)
    print(io, " at index [")
    show(io, ind)
    print(io, ']')
    nothing
end

# inline everything to help escape analysis

function throw_boundserrorlight(A::AbstractArray, i::Int)
    @inline
    throw(BoundsErrorLight(typeof(A), size(A), i))
end

function check_bounds_light(A::AbstractArray, i::Int)
    @inline
    checkbounds(Bool, A, i) || throw_boundserrorlight(A, i)
    nothing
end

module FixedSizeArrays

using Collects: Collect, collect_as

include("BoundsErrorLight.jl")

const default_underlying_storage_type = (@isdefined Memory) ? Memory : Vector

const optional_memory = (@isdefined Memory) ? (Memory,) : ()
const optional_atomic_memory = (@isdefined AtomicMemory) ? (AtomicMemory,) : ()
const optional_generic_memory = (@isdefined GenericMemory) ? (GenericMemory,) : ()

include("FixedSizeArray.jl")

if isdefined(Base, :dataids) && (Base.dataids isa Function)
    # This is an internal, non-public function which is nevertheless needed to
    # get good performance in some cases (e.g. broadcasting):
    # <https://github.com/JuliaArrays/FixedSizeArrays.jl/issues/63>.
    Base.dataids(a::FixedSizeArray) = Base.dataids(parent(a))
end

include("collect_as.jl")

end # module FixedSizeArrays

using Documenter: Documenter, makedocs, deploydocs
using FixedSizeArrays
using Changelog: Changelog

const GITHUB_REPO = "JuliaArrays/FixedSizeArrays.jl"

# Generate a Documenter-friendly changelog from CHANGELOG.md
Changelog.generate(
    Changelog.Documenter(),
    joinpath(@__DIR__, "..", "CHANGELOG.md"),
    joinpath(@__DIR__, "src", "release-notes.md");
    repo = GITHUB_REPO,
    branch = "main",
)

makedocs(
    modules = [FixedSizeArrays],
    sitename = "FixedSizeArrays",
    pages    = [
        "Introduction" => "index.md",
        "Installation" => "installation.md",
        "Usage" => "usage.md",
        "Reference" => "reference.md",
        "Release Notes" => "release-notes.md",
    ],
    format = Documenter.HTML(
        ;
        prettyurls = haskey(ENV, "CI"),
    ),
)

deploydocs(
    repo = "github.com/$(GITHUB_REPO).git",
    target = "build",
    deps = nothing,
    make = nothing,
    push_preview = true,
)

using Test
using LinearAlgebra, Adapt
using FixedSizeArrays
using Collects: collect_as
using OffsetArrays: OffsetArray
using Random: Random
import Aqua

# Check if the compilation options allow maximum performance.
const build_is_production_build_env_name = "BUILD_IS_PRODUCTION_BUILD"
const build_is_production_build = let v = get(ENV, build_is_production_build_env_name, "true")
    if v ∉ ("false", "true")
        error("unknown value for environment variable $build_is_production_build_env_name: $v")
    end
    if v == "true"
        true
    else
        false
    end
end::Bool

const checked_dims = FixedSizeArrays.checked_dims

# helpers for testing for allocation or suboptimal inference

allocated(f::F,      args::Tuple) where {F} = @allocated f(args...)
allocated(::Type{T}, args::Tuple) where {T} = @allocated T(args...)
test_noalloc(f::F,      args::Tuple) where {F} = build_is_production_build && @test iszero(allocated(f, args))
test_noalloc(::Type{T}, args::Tuple) where {T} = build_is_production_build && @test iszero(allocated(T, args))
function test_inferred(f::F,      ::Type{R}, args::Tuple) where {F,R}
    @test isconcretetype(R)  # meta: test-strictness test
    @test (@inferred f(args...)) isa R
end
function test_inferred(::Type{T}, ::Type{R}, args::Tuple) where {T,R}
    @test isconcretetype(R)  # meta: test-strictness test
    @test (@inferred T(args...)) isa R
end
test_inferred(::Type{T}, args::Tuple) where {T} = test_inferred(T, T, args)
function test_inferred_noalloc(f::F,      ::Type{R}, args::Tuple) where {F,R}
    test_noalloc(f, args)
    test_inferred(f, R, args)
end
function test_inferred_noalloc(::Type{T}, ::Type{R}, args::Tuple) where {T,R}
    test_noalloc(T, args)
    test_inferred(T, R, args)
end
function test_inferred_noalloc(::Type{T},            args::Tuple) where {T  }
    test_noalloc(T, args)
    test_inferred(T, args)
end

# helpers for constructing the type constructors

function fsa(vec_type::Type{<:DenseVector})
    FixedSizeArray{T,N,vec_type{T}} where {T,N}
end
function fsm(vec_type::Type{<:DenseVector})
    fsa(vec_type){T,2} where {T}
end
function fsv(vec_type::Type{<:DenseVector})
    fsa(vec_type){T,1} where {T}
end

function test_we_do_not_own_the_call(func, arg_types)
    function f(method)
        FixedSizeArrays != parentmodule(method)
    end
    @test all(f, methods(func, arg_types))
end

@testset "FixedSizeArrays" begin
    @testset "meta" begin
        @test isempty(detect_ambiguities(Main))  # test for ambiguities in this file
    end

    @testset "Aqua.jl" begin
        Aqua.test_all(FixedSizeArrays)
    end

    @testset "type piracy" begin
        @testset "issue #77: type piracy of `similar`" begin
            test_we_do_not_own_the_call(similar, Tuple{Broadcast.Broadcasted{Broadcast.ArrayStyle{Union{}}}, Type{Int}})
        end
    end

    @testset "type aliases" begin
        @test FixedSizeArrayDefault <: FixedSizeArray
        @test FixedSizeVectorDefault <: FixedSizeVector
        @test FixedSizeMatrixDefault <: FixedSizeMatrix
        for et ∈ (Float32, Int, String)
            @test FixedSizeArrayDefault{et} <: FixedSizeArray{et}
            @test FixedSizeVectorDefault{et} <: FixedSizeVector{et}
            @test FixedSizeMatrixDefault{et} <: FixedSizeMatrix{et}
            @test FixedSizeArrayDefault{et, 0} <: FixedSizeArray{et, 0}
            for t ∈ (
                FixedSizeVectorDefault{et}, FixedSizeMatrixDefault{et}, FixedSizeArrayDefault{et, 0},
            )
                @test isconcretetype(t)
            end
        end
        @test FixedSizeArrays.FixedSizeArrayAllowedConstructorType <: Type{<:FixedSizeArray}
    end

    @testset "safe computation of length from dimensions size" begin
        @test isone(checked_dims(()))
        for n ∈ 0:30
            t = Tuple(1:n)
            if 20 < n
                @test_throws ArgumentError checked_dims(t)
            else
                @test factorial(n) == prod(t) == checked_dims(t)
                test_inferred_noalloc(checked_dims, Int, (t,))
            end
        end
    end

    struct Iter{E,N,I<:Integer}
        size::NTuple{N,I}
        length::I
        val::E
    end
    function Base.iterate(i::Iter)
        l = i.length
        iterate(i, max(zero(l), l))
    end
    function Base.iterate(i::Iter, state::Int)
        if iszero(state)
            nothing
        else
            (i.val, state - 1)
        end
    end
    Base.IteratorSize(::Type{<:Iter{<:Any,N}}) where {N} = Base.HasShape{N}()
    Base.length(i::Iter) = i.length
    Base.size(i::Iter) = i.size
    Base.eltype(::Type{<:Iter{E}}) where {E} = E

    @testset "default underlying storage type" begin
        default = FixedSizeArrays.default_underlying_storage_type
        @test default === (@isdefined(Memory) ? Memory : Vector)
        return_type = FixedSizeVector{Int,default{Int}}
        @test return_type === FixedSizeVectorDefault{Int}
        test_inferred(FixedSizeArray{Int}, return_type, (undef, 3))
        test_inferred(FixedSizeArray{Int}, return_type, (undef, (3,)))
        test_inferred(FixedSizeVector{Int}, return_type, (undef, 3))
        test_inferred(FixedSizeVector{Int}, return_type, (undef, (3,)))
        iter = Iterators.filter(iseven, 3:7)
        @test collect_as(FixedSizeArray, iter) isa return_type
        test_inferred(collect_as, return_type, (FixedSizeArray{Int}, iter))
        test_inferred(collect_as, return_type, (FixedSizeVector{Int}, iter))
        arr = ([1, 2, 3],)
        test_inferred(FixedSizeArray, return_type, arr)
        test_inferred(FixedSizeVector, return_type, arr)
        test_inferred(FixedSizeArray{Int}, return_type, arr)
        test_inferred(FixedSizeVector{Int}, return_type, arr)
    end

    @testset "`undef` construction without element type" begin
        @test_throws MethodError FixedSizeVector(undef, 1)
        @test_throws MethodError FixedSizeMatrix(undef, 1, 1)
    end

    for storage_type ∈ (((@isdefined Memory) ? (Memory,) : ())..., Vector)
        FSV = fsv(storage_type)
        FSM = fsm(storage_type)
        FSA = fsa(storage_type)

        @testset "`propertynames`" begin
            for dim_count ∈ 0:4
                for T ∈ (Int, Float32)
                    siz = ntuple(Returns(1), dim_count)
                    arr = FSA{T}(undef, siz)
                    test_inferred(propertynames, Tuple{}, (arr,))
                    test_inferred(propertynames, Tuple{}, (arr, false))
                end
            end
        end

        @testset "Constructors" begin
            @testset "`undef` construction without element type" begin
                @test_throws MethodError FSV(undef, 1)
                @test_throws MethodError FSM(undef, 1, 1)
            end
            @testset "mismatched ndims" begin
                @test_throws DimensionMismatch FSV{Int}(undef)
                @test_throws DimensionMismatch FSV{Int}(undef, 1, 1)
                @test_throws DimensionMismatch FSM{Int}(undef)
                @test_throws DimensionMismatch FSM{Int}(undef, 1)
            end
            for dim_count ∈ 0:4
                siz = ntuple(Returns(2), dim_count)
                T = FSA{Float64}
                R = FSA{Float64,dim_count}
                for sz ∈ (siz, map(BigInt, siz))
                    for args ∈ ((undef, sz), (undef, sz...))
                        test_inferred(   R, args)
                        test_inferred(T, R, args)
                    end
                end
            end
            for offset ∈ (-1, 0, 2, 3)
                ax = offset:(offset + 1)
                oa = OffsetArray([10, 20], ax)
                @test_throws DimensionMismatch FSA{Int}(oa)
                @test_throws DimensionMismatch FSV{Int}(oa)
            end
            @testset "taken from Julia's test/core.jl" begin
                # inspired by:
                # https://github.com/JuliaLang/julia/blob/83929ad883c97fa4376618c4559b74f6ada7a3ce/test/core.jl#L7211-L7228
                b = prevpow(2, typemax(Int))
                test_inferred(FSA{Int}, FSA{Int,3}, (undef, 0, b, b))
                test_inferred(FSA{Int}, FSA{Int,3}, (undef, b, b, 0))
                test_inferred(FSA{Int}, FSA{Int,5}, (undef, b, b, 0, b, b))
                @test_throws ArgumentError FSA{Int}(undef, b, b)
                @test_throws ArgumentError FSA{Int}(undef, 1, b, b)
                @test_throws ArgumentError FSA{Int}(undef, 0, -10)
                @test_throws ArgumentError FSA{Int}(undef, -10, 0)
                @test_throws ArgumentError FSA{Int}(undef, -1, -1)
                @test_throws ArgumentError FSA{Int}(undef, 0, -4, -4)
                @test_throws ArgumentError FSA{Int}(undef, -4, 1, 0)
                @test_throws ArgumentError FSA{Int}(undef, -4, -4, 1)
            end
            @test_throws ArgumentError FSA{Float64,1}(undef, -1)
            @test_throws ArgumentError FSA{Float64,1}(undef, (-1,))
            @test_throws ArgumentError FSA{Float64,2}(undef, -1, -1)
            @test_throws ArgumentError FSA{Float64,2}(undef, typemax(Int), 0)
            @test_throws ArgumentError FSA{Float64,2}(undef, typemax(Int), typemax(Int))
            @test_throws ArgumentError FSA{Float64,3}(undef, typemax(Int)-1, typemax(Int)-1, 2)
            @test_throws ArgumentError FSA{Float64,4}(undef, typemax(Int)-1, typemax(Int)-1, 2, 4)
            @testset "negative dimension size" begin
                for n ∈ 2:4
                    funs = (
                        Returns(-1),
                        (i -> (i == 1) ?  1 : -1),
                        (i -> (i == 1) ? -1 :  1),
                        (i -> (i == n) ?  1 : -1),
                        (i -> (i == n) ? -1 :  1),
                    )
                    fun = f -> ntuple(f, n)
                    sizes = map(fun, funs)
                    for siz ∈ sizes
                        @test_throws ArgumentError FSA{Float64,n}(undef, siz)
                        @test_throws ArgumentError FSA{Float64,n}(undef, siz...)
                    end
                end
            end
        end

        @testset "constructors taking `AbstractArray`" begin
            @test [1, 2, 3] == (@inferred FSV([1, 2, 3]))::FSV{Int}
            @test [1, 2, 3] == (@inferred FSA([1, 2, 3]))::FSV{Int}
            @test [1, 2, 3] == (@inferred FSV(Any[1, 2, 3]))::FSV{Any}
            @test [1, 2, 3] == (@inferred FSA(Any[1, 2, 3]))::FSV{Any}
            @test [1, 2, 3] == (@inferred FSV(Real[1, 2, 3]))::FSV{Real}
            @test [1, 2, 3] == (@inferred FSA(Real[1, 2, 3]))::FSV{Real}
            @test [1, 2, 3] == (@inferred FSV{Float32}([1, 2, 3]))::FSV{Float32}
            @test [1, 2, 3] == (@inferred FSA{Float32}([1, 2, 3]))::FSV{Float32}
            @test_throws DimensionMismatch FSV(rand(Bool, 2, 2))
            @test_throws DimensionMismatch FSV{Float32}(rand(Bool, 2, 2))
            @test let v = FSV([1, 2, 3])
                v == (@inferred FSV(v))::typeof(v)
            end
            @test let v = FSV([1, 2, 3])
                v !== FSV(v)
            end
        end

        @testset "setindex!" begin
            v = FSV{Float64}(undef, 2)
            v[1] = 1
            v[2] = 2
            @test v[1] == 1
            @test v[2] == 2
        end

        @testset "out-of-bounds access" begin
            v0 = FSV([])
            v1 = FSV([3])
            @test_throws BoundsErrorLight v0[1]
            @test_throws BoundsErrorLight v1[2]
            @test_throws BoundsErrorLight v0[1] = 7
            @test_throws BoundsErrorLight v1[2] = 7
            exc_text = sprint(showerror, BoundsErrorLight(typeof(v1), size(v1), 2))
            @test startswith(exc_text, "BoundsErrorLight: ")
            @test endswith(exc_text, "[2]")
        end

        @testset "parent and parentindices" begin
            for size in ((4,), (3, 3), (2, 2, 2)), T in (UInt16, Int, Float32)
                a = FixedSizeArray{T}(undef, size)
                a .= 1
                p = parent(a)
                @test p === a.mem
                @test parentindices(a) === (Base.OneTo(length(a)),)
                # Make sure all the parent indices are valid
                for idx in Base.CartesianIndex.(collect.(parentindices(a))...)
                    @test p[idx] == 1
                end
            end
        end

        @testset "FixedSizeVector" begin
            v = FSV{Float64}(undef, 3)
            @test length(v) == 3
            test_inferred_noalloc(((a, b) -> a .= b), FSV{Float64}, (v, 1:3))
            @test v == 1:3
            test_inferred(similar, FSV{Float64}, (v,))
            test_inferred(similar, FSV{Int}, (v, Int))
            test_inferred(copy, FSV{Float64}, (v,))
            test_inferred(zero, FSV{Float64}, (v,))
            test_inferred(similar, FSV{Int}, (FSV{Int}, (2,)))
            test_inferred(similar, FSV{Int}, (FSA{Int}, (2,)))
            example_abstract_vectors = (7:9, [7, 8, 9], OffsetArray([7, 8, 9], 1:3))
            for T in (FSA{Int}, FSV{Int}), arr in example_abstract_vectors
                # Don't allow conversion:
                # <https://github.com/JuliaArrays/FixedSizeArrays.jl/issues/120>.
                @test_throws MethodError convert(T, arr)
            end
        end

        @testset "FixedSizeMatrix" begin
            m = FSM{Float64}(undef, 3, 3)
            m_ref = reshape(1:9, size(m))
            @test length(m) == 9
            test_inferred_noalloc(((a, b) -> a .= b), FSM{Float64}, (m, m_ref))
            @test m == m_ref
            test_inferred(similar, FSM{Float64}, (m,))
            test_inferred(similar, FSM{Int}, (m, Int))
            test_inferred(copy, FSM{Float64}, (m,))
            test_inferred(zero, FSM{Float64}, (m,))
            test_inferred(similar, FSM{Int}, (FSM{Int}, (2, 3)))
            test_inferred(similar, FSM{Int}, (FSA{Int}, (2, 3)))
            example_abstract_matrices = (
                reshape(1:9, (3, 3)),
                OffsetArray(reshape(1:9, (3, 3)), 1:3, 1:3),
            )
            for T in (FSA{Int}, FSM{Int}), arr in example_abstract_matrices
                # Don't allow conversion:
                # <https://github.com/JuliaArrays/FixedSizeArrays.jl/issues/120>.
                @test_throws MethodError convert(T, arr)
            end
        end

        @testset "`map`" begin
            for dim_count ∈ 0:3
                size = ntuple(Returns(3), dim_count)
                a = FSA{Int, dim_count}(undef, size)
                for v ∈ (3, 3.1, nothing)
                    args = (Returns(v), a)
                    @test all(==(v), map(args...))
                    test_inferred(map, FSA{typeof(v), dim_count}, args)
                end
            end
        end

        @testset "broadcasting" begin
            TVI = FSV{Int}
            TVF = FSV{Float64}
            v3 = TVI(1:3)
            vf3 = TVF(1:3)
            bp = (x, y) -> x .+ y
            bm = (x, y) -> x .* y
            test_inferred(+,  TVI, (v3, v3))
            test_inferred(bp, TVI, (v3, v3))
            test_inferred(bm, TVI, (v3, v3))
            test_inferred(+,  TVF, (v3, vf3))
            test_inferred(bp, TVF, (v3, vf3))
            test_inferred(bm, TVF, (v3, vf3))
            test_inferred(bp, TVI, (v3,  3))
            test_inferred(bm, TVI, (v3,  3))
            test_inferred(bp, TVF, (v3, .3))
            test_inferred(bm, TVF, (v3, .3))
            @testset "views" begin
                va = @view TVI(1:3)[1:2]
                vb = @view TVI(4:6)[2:3]
                vf2 = TVF(7:8)
                test_inferred(+,  TVI, (va,  vb))
                test_inferred(+,  TVF, (va, vf2))
                test_inferred(+,  TVF, (vf2, vb))
                test_inferred(bp, TVI, (va, vb))
                test_inferred(bp, TVF, (va, vf2))
                test_inferred(bp, TVF, (vf2, vb))
                test_inferred(-,  TVI, (va, vb))
                test_inferred(-,  TVF, (va, vf2))
                test_inferred(-,  TVF, (vf2, vb))
                test_inferred(bm, TVI, (va, vb))
                test_inferred(bm, TVF, (va, vf2))
                test_inferred(bm, TVF, (vf2, vb))
            end
            @testset "matrices" begin
                TMI = FSM{Int}
                TMF = FSM{Float64}
                m33 = TMI(undef, 3, 3)
                m13 = TMI(undef, 1, 3)
                m31 = TMI(undef, 3, 1)
                test_inferred(+,  TMI, (m33, m33))
                test_inferred(bp, TMI, (m33, m33))
                test_inferred(bm, TMI, (m33, m33))
                test_inferred(bp, TMI, (m33, m13))
                test_inferred(bm, TMI, (m33, m13))
                test_inferred(bp, TMI, (m33, m31))
                test_inferred(bm, TMI, (m33, m31))
                test_inferred(bp, TMI, (m33, v3 ))
                test_inferred(bm, TMI, (m33, v3 ))
                test_inferred(bp, TMF, (m33, vf3))
                test_inferred(bm, TMF, (m33, vf3))
                test_inferred(bp, TMI, (m33,   3))
                test_inferred(bm, TMI, (m33,   3))
                test_inferred(bp, TMF, (m33,  .3))
                test_inferred(bm, TMF, (m33,  .3))
                vm22 = @view m33[1:2, 2:3]
                mf22 = TMF(undef, 2, 2)
                test_inferred(+,  TMI, (vm22, vm22))
                test_inferred(+,  TMF, (vm22, mf22))
                test_inferred(+,  TMF, (mf22, vm22))
                test_inferred(bp, TMI, (vm22, vm22))
                test_inferred(bp, TMF, (vm22, mf22))
                test_inferred(bp, TMF, (mf22, vm22))
                test_inferred(-,  TMI, (vm22, vm22))
                test_inferred(-,  TMF, (vm22, mf22))
                test_inferred(-,  TMF, (mf22, vm22))
                test_inferred(bm, TMI, (vm22, vm22))
                test_inferred(bm, TMF, (vm22, mf22))
                test_inferred(bm, TMF, (mf22, vm22))
            end
        end

        @testset "`isassigned`" begin
            for dim_count ∈ 0:3
                for elem_type ∈ (Int, FSM{Nothing})
                    size = ntuple(Returns(3), dim_count)
                    a = FSA{elem_type, dim_count}(undef, size)
                    for i_style ∈ (IndexLinear(), IndexCartesian())
                        for i ∈ eachindex(i_style, a)
                            @test isassigned(a, i) == isbitstype(elem_type)
                            test_inferred_noalloc(isassigned, Bool, (a, i))
                        end
                    end
                end
            end
            @testset "some assigned" begin
                a = FSM{FSM{Nothing}}(undef, 3, 3)
                assigned_inds = ((1, 2), (2, 3), (3, 3))
                for ij ∈ assigned_inds
                    a[ij...] = FSM{Nothing}(undef, 1, 1)
                end
                for ij ∈ Iterators.product(1:3, 1:3)
                    @test isassigned(a, ij...) == (ij ∈ assigned_inds)
                    test_inferred_noalloc(isassigned, Bool, (a, ij...))
                end
            end
        end

        @testset "`copy`" begin
            m = FixedSizeArray(rand(2, 2))::FixedSizeArray
            @test m == copy(m)
            @test m !== copy(m)
            @test m == m[:]
            @test m !== m[:]
        end

        @testset "`copyto!`" begin
            for (D, S) ∈ (
                (Vector, FSV),
                (FSV, Vector),
                (FSV, FSV),
                (
                    if @isdefined Memory
                        ((FSV, Memory), (Memory, FSV))
                    else
                        ()
                    end
                )...,
            )
                for E ∈ (Float64, Int)
                    s = S{E}(undef, 5)
                    s .= 1:5
                    d = D{Float64}(undef, 5)
                    test_inferred_noalloc(copyto!, D{Float64}, (d, s))
                    @test copyto!(d, s) == 1:5
                    args = (d, 1, s, 1, length(s))
                    test_inferred_noalloc(copyto!, D{Float64}, args)
                    @test copyto!(args...) == 1:5
                    @test_throws ArgumentError copyto!(d, 1, s, 1, -1)
                end
            end
        end

        @testset "LinearAlgebra" begin
            @testset "$T" for T in (Float16, Float32, Float64)
                v = randn(T, 8)
                v_fixed = FSV{T}(v)
                test_inferred(+, FSV{T}, (v_fixed, v_fixed))
                v_sum = v_fixed + v_fixed
                @test v_sum ≈ v + v
                test_inferred(((x, y) -> x * y'), FSM{T}, (v_fixed, v_fixed))
                v_mul = v_fixed * v_fixed'
                @test v_mul ≈ v * v'

                M = randn(T, 8, 8)
                M_fixed = FSM{T}(M)
                test_inferred(+, FSM{T}, (M_fixed, M_fixed))
                M_sum = M_fixed + M_fixed
                @test M_sum ≈ M + M
                test_inferred(*, FSM{T}, (M_fixed, M_fixed))
                M_mul = M_fixed * M_fixed
                @test M_mul ≈ M * M
            end
        end

        @testset "`pointer`" begin
            for elem_type ∈ (Int8, Int16, Int32, Int64)
                for dim_count ∈ 0:4
                    siz = ntuple(Returns(2), dim_count)
                    arr = FSA{elem_type, dim_count}(undef, siz)
                    @test pointer(arr) === pointer(arr, 1) === pointer(arr, 2) - sizeof(elem_type)
                    test_inferred_noalloc(pointer, Ptr{elem_type}, (arr,))
                    test_inferred_noalloc(pointer, Ptr{elem_type}, (arr, 1))
                end
            end
        end

        @testset "`reshape`" begin
            length_to_shapes = Dict(
                (0 => ((0,), (0, 0), (0, 1), (1, 0), (1, 0, 0), (0, 0, 1))),
                (1 => ((), (1,), (1, 1), (1, 1, 1))),
                (2 => ((2,), (1, 2), (2, 1), (1, 2, 1))),
                (3 => ((3,), (1, 3), (3, 1), (1, 3, 1))),
                (4 => ((4,), (1, 4), (4, 1), (2, 2), (1, 2, 2), (2, 1, 2))),
                (6 => ((6,), (1, 6), (6, 1), (2, 3), (3, 2), (1, 3, 2), (2, 1, 3))),
            )
            for elem_type ∈ (Int, Number, Union{Nothing,Int})
                for len ∈ keys(length_to_shapes)
                    shapes = length_to_shapes[len]
                    for shape1 ∈ shapes
                        a = FSA{elem_type,length(shape1)}(undef, shape1)
                        @test_throws DimensionMismatch reshape(a, length(a)+1)
                        @test_throws DimensionMismatch reshape(a, length(a)+1, 1)
                        @test_throws DimensionMismatch reshape(a, 1, length(a)+1)
                        for shape2 ∈ shapes
                            @test prod(shape1) === prod(shape2) === len  # meta
                            T = FSA{elem_type,length(shape2)}
                            test_inferred_noalloc(reshape, T, (a, shape2))
                            test_inferred_noalloc(reshape, T, (a, shape2...))
                            b = reshape(a, shape2)
                            @test size(b) === shape2
                            @test parent(a) === parent(b)
                            @test a === reshape(b, shape1)
                        end
                    end
                end
            end
        end

        @testset "`collect_as`" begin
            @testset "difficult requested return type" begin
                T = FixedSizeVectorDefault{T} where {T <: Float32}
                iter = 3:7
                # either return a value of the requested type or throw
                returns = try
                    collect_as(T, iter)
                    true
                catch e
                    (e isa ArgumentError) || rethrow()
                    false
                end
                returns && @test collect_as(T, iter) isa T
            end
            @testset "empty iterator with inexact `eltype`" begin
                iterator = Iterators.map((x -> x + 0.3), [])
                @test collect_as(FSV, iterator; empty_iterator_handler = Returns(Union{})) isa FSV{Union{}}
                @test collect_as(FSV{Union{}}, iterator) isa FSV{Union{}}
                @test collect_as(FSV{Float32}, iterator) isa FSV{Float32}
                @test collect_as(FSV{Any}, iterator) isa FSV{Any}
                @test_throws ArgumentError collect_as(FSV, iterator)
            end
            @testset "explicit handling of empty iterators" begin
                @test [] == collect_as(FSV, []; empty_iterator_handler = Returns(Union{}))::FixedSizeArray{Union{}}
                @test [] == collect_as(FSV, []; empty_iterator_handler = Returns(Bool))::FixedSizeArray{Bool}
            end
            @testset "`Union{}`" begin
                @test_throws Exception collect_as(Union{}, ())
                @test_throws Exception collect_as(FixedSizeVector{Union{}, Union{}}, ())
                @test_throws Exception collect_as(FixedSizeVector{<:Any, Union{}}, ())
            end
            for T ∈ (FSA{Int}, FSV{Int})
                for iterator ∈ (Iterators.repeated(7), Iterators.cycle(7))
                    @test_throws ArgumentError collect_as(T, iterator)
                end
            end
            @test_throws DimensionMismatch collect_as(FSA{Int, -1}, 7:8)
            @test_throws TypeError collect_as(FSA{Int, 3.1}, 7:8)
            for T ∈ (FSA{3}, FSV{3})
                iterator = (7:8, (7, 8))
                @test_throws MethodError collect_as(T, iterator)
            end
            @testset "buggy iterator with mismatched `size` and `length" begin
                for iterator ∈ (Iter((), 0, 7), Iter((3, 2), 5, 7))
                    E = eltype(iterator)
                    dim_count = length(size(iterator))
                    for T ∈ (FSA{E}, FSA{E,dim_count})
                        @test_throws DimensionMismatch collect_as(T, iterator)
                    end
                end
            end
            iterators = (
                (), (7,), (7, 8), 7, (7 => 8), Ref(7), fill(7),
                (i for i ∈ 1:3), ((i + 100*j) for i ∈ 1:3, j ∈ 1:2), Iterators.repeated(7, 2),
                (i for i ∈ 7:9 if i==8), 7:8, 8:7, map(BigInt, 7:8), Int[], [7], [7 8],
                Iter((), 1, 7), Iter((3,), 3, 7), Iter((3, 2), 6, 7),
                (i for i ∈ (false, 0x1, 2) if Bool(2 - 1)),
                (i + false for i ∈ (false, 0x1, 2) if Bool(2 - 2)),
                Iterators.filter(<(1), Int[]),
            )
            abstract_array_params(::AbstractArray{T,N}) where {T,N} = (T, N)
            @testset "iterator: $iterator" for iterator ∈ iterators
                a = collect(iterator)
                (E, dim_count) = abstract_array_params(a)
                af = collect(Float64, iterator)
                @test abstract_array_params(af) == (Float64, dim_count)  # meta
                iszero(dim_count) ||
                @test_throws DimensionMismatch collect_as(FSA{E,dim_count+1}, iterator)
                for T ∈ (FSA{E}, FSA{E,dim_count})
                    test_inferred(collect_as, FSA{E,dim_count}, (T, iterator))
                    fsa = collect_as(T, iterator)
                    @test a == fsa
                    @test first(abstract_array_params(fsa)) <: E
                end
                # `collect_as` throws by default when given an empty iterator with imprecise `eltype`
                (isconcretetype(eltype(iterator)) || (eltype(iterator) <: Union{}) || !isempty(iterator)) &&
                for T ∈ (FSA, FSA{<:Any,dim_count})
                    @test collect_as(T, iterator) isa FSA{E,dim_count}
                    fsa = collect_as(T, iterator)
                    @test a == fsa
                    @test first(abstract_array_params(fsa)) <: E
                end
                for T ∈ (FSA{Float64}, FSA{Float64,dim_count})
                    test_inferred(collect_as, FSA{Float64,dim_count}, (T, iterator))
                    fsa = collect_as(T, iterator)
                    @test af == fsa
                    @test first(abstract_array_params(fsa)) <: Float64
                end
                # `collect_as` throws by default when given an empty iterator with imprecise `eltype`
                (isconcretetype(eltype(iterator)) || (eltype(iterator) <: Union{}) || !isempty(iterator)) &&
                for T ∈ (FixedSizeArray{<:Any,dim_count},)
                    @test collect_as(T, iterator) isa FixedSizeArray{E,dim_count}
                    fsa = collect_as(T, iterator)
                    @test a == fsa
                    @test first(abstract_array_params(fsa)) <: E
                end
            end
        end
    end

    @testset "Random" begin
        for T in (Float16, Float32, Float64),
            N in (4, 16, 64, 128, 256),
            seed in (17, 42, 123, 5745192337902587512),
            rng in (Random.default_rng(), Random.MersenneTwister())

            v = FixedSizeArrays.default_underlying_storage_type{T}(undef, N)
            fv = FixedSizeVectorDefault{T}(undef, N)
            rng1 = Random.seed!(rng, seed)
            Random.rand!(rng1, v)
            rng2 = Random.seed!(rng, seed)
            # Make sure `rand!` returns `fv` itself.
            @test Random.rand!(rng2, fv) === fv
            # Make sure rand!(::FixedSizeArrays) generates same stream of
            # numbers as rand!(::Memory)
            @test v == fv
        end
    end

    @testset "Adapt" begin
        # Preserver wrapper types:
        arr = transpose([10 20; 30 14])
        farr = adapt(FixedSizeArray, arr)
        @test farr isa Transpose
        @test parent(farr) isa FixedSizeArray
    end
end

module RandomExt

using Random: Random
using FixedSizeArrays: FixedSizeArray

function Random.rand!(rng::Random.AbstractRNG, A::FixedSizeArray{T,N}, sp::Random.Sampler) where {N,T}
    Random.rand!(rng, parent(A), sp)
    return A
end

# Methods needed only to resolve ambiguities, we don't care too much about them
function Random.rand!(r::Random.MersenneTwister, A::FixedSizeArray{Float64,N}, I::Random.SamplerTrivial{<:Random.FloatInterval{Float64}}) where {N}
    Random.rand!(r, parent(A), I)
    return A
end

if VERSION < v"1.11"
    function Random.rand!(::Random._GLOBAL_RNG, A::FixedSizeArray{Float64,N}, I::Random.SamplerTrivial{<:Random.FloatInterval{Float64}}) where {N}
        Random.rand!(Random.default_rng(), parent(A), I)
        return A
    end
end

end # module RandomExt

function (::Collect)(::Type{<:(FixedSizeArray{E, N, Union{}} where {E, N})}, ::Any)
    throw(ArgumentError("`Union{}` not expected"))
end

function infer_ndims_impl(::Base.HasShape{N}) where {N}
    N::Int
end

function infer_ndims_impl(::Base.IteratorSize)
    1
end

function infer_ndims(iterator)
    infer_ndims_impl(Base.IteratorSize(iterator))
end

function inferred_shape_impl(output_ndims::Int, iterator)
    if (!isone(output_ndims)) && (output_ndims != infer_ndims(iterator))
        throw(DimensionMismatch("mismatched dimensionalities"))
    end
    if iszero(output_ndims)
        ()
    elseif isone(output_ndims)
        (:,)
    else
        size(iterator)
    end
end

function inferred_shape(::Type{<:(AbstractArray{T, N} where {T})}, iterator) where {N}
    inferred_shape_impl(N::Int, iterator)
end

function inferred_shape(::Type{<:AbstractArray}, iterator)
    inferred_shape_impl(infer_ndims(iterator), iterator)
end

function (collect::Collect)(::Type{FSA}, iterator) where {FSA<:FixedSizeArray}
    T = check_constructor_is_allowed(FSA)
    if iterator isa FSA
        return copy(iterator)
    end
    mem = parent_type_with_default(T)
    shape = inferred_shape(T, iterator)
    backing = collect(mem, iterator)
    fsv = new_fixed_size_array(backing, (length(backing),))
    reshape(fsv, shape)
end

function collect_as_haseltype(::Type{FSA}, iterator) where {T, FSA<:FixedSizeArray{T}}
    collect_as(check_constructor_is_allowed(FSA), iterator)
end

function collect_as_haseltype(::Type{FSA}, iterator) where {FSA<:FixedSizeArray}
    T = check_constructor_is_allowed(FSA){eltype(iterator)}
    collect_as(T, iterator)
end

export
    BoundsErrorLight,
    FixedSizeArray, FixedSizeVector, FixedSizeMatrix,
    FixedSizeArrayDefault, FixedSizeVectorDefault, FixedSizeMatrixDefault

"""
    FixedSizeArray{T,N,Mem<:DenseVector{T}}(undef, size::NTuple{N,Int})
    FixedSizeArray{T,N,Mem<:DenseVector{T}}(undef, size1::Int, size2::Int, ...)
    FixedSizeArray{T,N,Mem<:DenseVector{T}}(array::AbstractArray)

Construct a fixed-size `FixedSizeArray` with element type `T`, number of dimensions `N`, and memory backend `Mem`.

Convenient aliases provided:

* [`FixedSizeVector{T,Mem}`](@ref): for 1-dimensional fixed-size arrays
* [`FixedSizeMatrix{T,Mem}`](@ref): for 2-dimensional fixed-size arrays
* [`FixedSizeArrayDefault{T,N}`](@ref): for `N`-dimensional fixed-size arrays, with default memory backend
* [`FixedSizeVectorDefault{T}`](@ref): for 1-dimensional fixed-size arrays, with default memory backend
* [`FixedSizeMatrixDefault{T}`](@ref): for 2-dimensional fixed-size arrays, with default memory backend
"""
struct FixedSizeArray{T,N,Mem<:DenseVector{T}} <: DenseArray{T,N}
    mem::Mem
    size::NTuple{N,Int}
    global function new_fixed_size_array(mem::DenseVector{T}, size::NTuple{N,Int}) where {T,N}
        new{T,N,typeof(mem)}(mem, size)
    end
end

function Base.propertynames(
    # the `unused` is here because of https://github.com/JuliaLang/julia/issues/44428
    (@nospecialize unused::FixedSizeArray),
    ::Bool = false,
)
    ()
end

const FixedSizeArrayAllowedConstructorType = let
    function f(Mem::UnionAll)
        Union{
            # 0 fixed parameters
            Type{FixedSizeArray{T, N, Mem{T}} where {T, N}},
            # 1 fixed parameter
            Type{FixedSizeArray{T, N, Mem{T}} where {T}} where {N},
        }
    end
    special_storage_types = (Vector, optional_memory...)
    Union{
        # 0 fixed parameters
        Type{FixedSizeArray},
        # 1 fixed parameter
        Type{FixedSizeArray{T}} where {T},
        Type{FixedSizeArray{T, N} where {T}} where {N},
        # 2 fixed parameters
        Type{FixedSizeArray{T, N}} where {T, N},
        Type{FixedSizeArray{T, N, Mem} where {N}} where {T, Mem <: DenseVector{T}},
        # 3 fixed parameters
        Type{FixedSizeArray{T, N, Mem}} where {T, N, Mem <: DenseVector{T}},
        # special cases depending on the underlying storage type
        map(f, special_storage_types)...,
    }
end

function check_constructor_is_allowed(::Type{T}) where {T <: FixedSizeArray}
    if Type{T} <: FixedSizeArrayAllowedConstructorType
        T
    else
        throw(ArgumentError("technical limitation: type is not among the allowed `FixedSizeArray` constructors (try deleting type parameter constraints)"))
    end
end

"""
    FixedSizeVector{T,Mem<:DenseVector{T}}(undef, size::NTuple{1,Int})
    FixedSizeVector{T,Mem<:DenseVector{T}}(undef, size1::Int)
    FixedSizeVector{T,Mem<:DenseVector{T}}(array::AbstractVector)

Construct a fixed-size 1-dimensional [`FixedSizeArray`](@ref) with element type `T`, and memory backend `Mem`.

Convenient aliases provided:

* [`FixedSizeVectorDefault{T}`](@ref): for 1-dimensional fixed-size arrays, with default memory backend
"""
const FixedSizeVector{T} = FixedSizeArray{T,1}
"""
    FixedSizeMatrix{T,Mem<:DenseMatrix{T}}(undef, size::NTuple{2,Int})
    FixedSizeMatrix{T,Mem<:DenseMatrix{T}}(undef, size1::Int, size2::Int)
    FixedSizeMatrix{T,Mem<:DenseMatrix{T}}(array::AbstractMatrix)

Construct a fixed-size 2-dimensional [`FixedSizeArray`](@ref) with element type `T`, and memory backend `Mem`.

Convenient aliases provided:

* [`FixedSizeMatrixDefault{T}`](@ref): for 2-dimensional fixed-size arrays, with default memory backend
"""
const FixedSizeMatrix{T} = FixedSizeArray{T,2}

function parent_type_with_default(::Type{<:(FixedSizeArray{T, N, Mem} where {N})}) where {T, Mem <: DenseVector{T}}
    Mem
end
function parent_type_with_default(::Type{<:FixedSizeArray{T}}) where {T}
    default_underlying_storage_type{T}
end
function parent_type_with_default(::Type{<:FixedSizeArray})
    default_underlying_storage_type
end
for Mem ∈ (Vector, optional_memory...)
    FSA = FixedSizeArray{T, N, Mem{T}} where {T, N}
    t_fsa = Union{
        Type{FSA},
        Type{FSA{T, N} where {T}} where {N},
    }
    @eval begin
        function parent_type_with_default(::$t_fsa)
            $Mem
        end
    end
end

function check_ndims(::Type{<:(FixedSizeArray{T, N} where {T})}, size::Tuple{Vararg{Integer}}) where {N}
    if size isa Tuple{Vararg{Any, N}}
        size
    else
        throw(DimensionMismatch("mismatch between dimension count in type and the length of the size tuple"))
    end
end
function check_ndims(::Type{<:FixedSizeArray}, size::Tuple{Vararg{Integer}})
    size
end

function undef_constructor(::Type{FSA}, size::Tuple{Vararg{Integer}}) where {T, FSA <: FixedSizeArray{T}}
    size = check_ndims(FSA, size)
    s = map(Int, size)
    Mem = parent_type_with_default(FSA)
    len = checked_dims(s)
    mem = Mem(undef, len)
    new_fixed_size_array(mem, s)
end

function (::Type{FSA})(::UndefInitializer, size::Tuple{Vararg{Integer}}) where {T, FSA <: FixedSizeArray{T}}
    undef_constructor(FSA, size)
end
function (::Type{FSA})(::UndefInitializer, size::Vararg{Integer}) where {T, FSA <: FixedSizeArray{T}}
    undef_constructor(FSA, size)
end

macro assume_noub_if_noinbounds(x)
    expr = :(
        let f
            Base.@assume_effects :noub_if_noinbounds f() = 7
        end
    )
    effect_is_recognized = try
        eval(expr)
        true
    catch
        false
    end
    if effect_is_recognized
        :(Base.@assume_effects :noub_if_noinbounds $x)
    else
        x
    end
end

Base.IndexStyle(::Type{<:FixedSizeArray}) = IndexLinear()
Base.@propagate_inbounds function Base.getindex(A::FixedSizeArray, i::Int)
    @boundscheck check_bounds_light(A, i)
    @inbounds parent(A)[i]
end
Base.@propagate_inbounds @assume_noub_if_noinbounds function Base.setindex!(A::FixedSizeArray, x, i::Int)
    @boundscheck check_bounds_light(A, i)
    @inbounds parent(A)[i] = x
    return A
end

Base.size(a::FixedSizeArray) = getfield(a, :size)

function Base.similar(::T, ::Type{E}, size::NTuple{N,Int}) where {T<:FixedSizeArray,E,N}
    spec = TypeParametersElementTypeAndDimensionality()
    S = val_parameter(with_stripped_type_parameters(spec, T)){E, N}
    S(undef, size)
end

Base.isassigned(a::FixedSizeArray, i::Int) = isassigned(parent(a), i)

# safe product of a tuple of integers, for calculating dimensions size

checked_dims_impl(a::Int, ::Tuple{}, have_overflow::Bool) = (a, have_overflow)
function checked_dims_impl(a::Int, t::Tuple{Int,Vararg{Int,N}}, have_overflow::Bool) where {N}
    b = first(t)
    (m, o) = Base.Checked.mul_with_overflow(a, b)
    r = Base.tail(t)::NTuple{N,Int}
    checked_dims_impl(m, r, have_overflow | o)::Tuple{Int,Bool}
end

checked_dims(::Tuple{}) = 1
function checked_dims(t::Tuple{Int,Vararg{Int,N}}) where {N}
    any_is_zero     = any(iszero,                 t)::Bool
    any_is_negative = any((x -> x < false),       t)::Bool
    any_is_typemax  = any((x -> x == typemax(x)), t)::Bool
    a = first(t)
    r = Base.tail(t)::NTuple{N,Int}
    (product, have_overflow) = checked_dims_impl(a, r, false)::Tuple{Int,Bool}
    if any_is_negative
        throw(ArgumentError("array dimension size can't be negative"))
    end
    if any_is_typemax
        throw(ArgumentError("array dimension size can't be the maximum representable value"))
    end
    if have_overflow & !any_is_zero
        throw(ArgumentError("array dimensions too great, can't represent length"))
    end
    product
end

# broadcasting

struct FixedSizeArrayBroadcastStyle{N, Mem <: DenseVector} <: Broadcast.AbstractArrayStyle{N} end

function (::Type{<:(FixedSizeArrayBroadcastStyle{N, Mem} where {N})})(::Val{M}) where {Mem, M}
    m = check_count_value(M)
    FixedSizeArrayBroadcastStyle{m, Mem}()  # `FixedSizeArray` supports any dimensionality
end

function Base.BroadcastStyle(::Union{Type{<:(FixedSizeArray{T, N, Mem} where {T})},
                                     Type{<:(SubArray{T, N, FixedSizeArray{T, N, Mem}} where {T})}}) where {N, Mem}
    n = check_count_value(N)
    spec = TypeParametersElementType()
    mem = val_parameter(with_stripped_type_parameters(spec, Mem))
    FixedSizeArrayBroadcastStyle{n, mem}()
end

function Base.similar(
    bc::Broadcast.Broadcasted{FixedSizeArrayBroadcastStyle{N, Mem}},
    ::Type{T},
) where {N,Mem,T}
    similar(FixedSizeArray{T, N, Mem{T}}, axes(bc))
end

# helper functions

val_parameter(::Val{P}) where {P} = P

struct TypeParametersElementType end
struct TypeParametersElementTypeAndDimensionality end

"""
    with_stripped_type_parameters_unchecked(spec, t::Type)::Val{s}

An implementation detail of [`with_stripped_type_parameters`](@ref). Don't call
directly.
"""
function with_stripped_type_parameters_unchecked end
function with_stripped_type_parameters_unchecked(::TypeParametersElementType, ::Type{<:Vector})
    s = Vector
    Val{s}()
end
(@isdefined GenericMemory) &&
function with_stripped_type_parameters_unchecked(::TypeParametersElementType, ::Type{<:(GenericMemory{K, T, AS} where {T})}) where {K, AS}
    s = GenericMemory{K, T, AS} where {T}
    Val{s}()
end

# `Base.@assume_effects :consistent` is a workaround for:
# https://github.com/JuliaLang/julia/issues/56966
Base.@assume_effects :consistent function with_stripped_type_parameters_unchecked(::TypeParametersElementTypeAndDimensionality, ::Type{<:(FixedSizeArray{T, N, Mem} where {T, N})}) where {Mem}
    spec_mem = TypeParametersElementType()
    mem_v = with_stripped_type_parameters(spec_mem, Mem)
    mem = val_parameter(mem_v)
    s = FixedSizeArray{T, N, mem{T}} where {T, N}
    Val{s}()
end

"""
    with_stripped_type_parameters(spec, t::Type)::Val{s}

The type `s` is a `UnionAll` supertype of `t`:

```julia
(s isa UnionAll) && (t <: s)
```

Furthermore, `s` has type variables in place of the type parameters specified
via `spec`.

NB: `Val{s}()` is returned instead of `s` so the method would be *consistent*
from the point of view of Julia's effect inference, enabling constant folding.

NB: this function is supposed to only have the one method. To add
functionality, add methods to [`with_stripped_type_parameters_unchecked`](@ref).
"""
function with_stripped_type_parameters(spec, t::Type)
    ret = with_stripped_type_parameters_unchecked(spec, t)
    s = val_parameter(ret)
    s = s::UnionAll
    Val{s}()
end

dimension_count_of(::Base.SizeUnknown) = 1
dimension_count_of(::Base.HasLength) = 1
dimension_count_of(::Base.HasShape{N}) where {N} = convert(Int, N)::Int

function check_count_value(n)
    n = n::Int
    if n < 0
        throw(ArgumentError("count can't be negative"))
    end
    n
end

parent_type(::Type{<:FixedSizeArray{<:Any,<:Any,Mem}}) where {Mem} = Mem

"""
    parent(f::FixedSizeArray)

Return the underlying parent object of the fixed-size array `f`.
Use `parentindices(f)` to get the valid indices of the parent of `f`.
"""
Base.parent(f::FixedSizeArray) = getfield(f, :mem)

Base.parentindices(f::FixedSizeArray) = axes(parent(f))

underlying_storage(m) = m
underlying_storage(f::FixedSizeArray) = parent(f)

axes_are_one_based(axes) = all(isone ∘ first, axes)

# converting constructors for copying other array types

function converting_constructor(::Type{FSA}, src::AbstractArray) where {FSA <: FixedSizeArray}
    axs = axes(src)
    if !axes_are_one_based(axs)
        throw(DimensionMismatch("source array has a non-one-based indexing axis"))
    end
    collect_as_haseltype(FSA, src)
end

function (::Type{FSA})(src::AbstractArray) where {N, FSA <: FixedSizeArray{<:Any, N}}
    if N::Int != ndims(src)
        throw(DimensionMismatch("dimensionality mismatch"))
    end
    converting_constructor(FSA, src)
end

function (::Type{FSA})(src::AbstractArray) where {FSA <: FixedSizeArray}
    converting_constructor(FSA, src)
end

# `copy`: avoid the `similar` and `copyto!` in the generic fallback

function Base.copy(a::FixedSizeArray)
    new_fixed_size_array(copy(Base.parent(a)), size(a))
end

# `getindex` with a `Colon` for the index: better effects than with the generic fallback

function Base.getindex(a::FixedSizeArray, ::Colon)
    copy(a)
end

# `copyto!`

Base.@propagate_inbounds function copyto5!(dst, doff, src, soff, n)
    copyto!(underlying_storage(dst), doff, underlying_storage(src), soff, n)
    dst
end

Base.@propagate_inbounds function copyto2!(dst, src)
    copyto!(underlying_storage(dst), underlying_storage(src))
    dst
end

Base.@propagate_inbounds Base.copyto!(dst::FixedSizeArray, doff::Integer, src::FixedSizeArray, soff::Integer, n::Integer) = copyto5!(dst, doff, src, soff, n)
Base.@propagate_inbounds Base.copyto!(dst::FixedSizeArray, src::FixedSizeArray) = copyto2!(dst, src)

for A ∈ (Array, optional_generic_memory...)  # Add more? Too bad we have to hardcode to avoid ambiguity.
    @eval begin
        Base.@propagate_inbounds Base.copyto!(dst::FixedSizeArray, doff::Integer, src::$A,             soff::Integer, n::Integer) = copyto5!(dst, doff, src, soff, n)
        Base.@propagate_inbounds Base.copyto!(dst::$A,             doff::Integer, src::FixedSizeArray, soff::Integer, n::Integer) = copyto5!(dst, doff, src, soff, n)

        Base.@propagate_inbounds Base.copyto!(dst::FixedSizeArray, src::$A            ) = copyto2!(dst, src)
        Base.@propagate_inbounds Base.copyto!(dst::$A,             src::FixedSizeArray) = copyto2!(dst, src)
    end
end

# unsafe: the native address of the array's storage

Base.cconvert(::Type{<:Ptr}, a::FixedSizeArray) = parent(a)

function Base.unsafe_convert(::Type{Ptr{T}}, a::FixedSizeArray{T}) where {T}
    Base.unsafe_convert(Ptr{T}, parent(a))
end

# `elsize`: part of the strided arrays interface, used for `pointer`

Base.elsize(::Type{A}) where {A<:FixedSizeArray} = Base.elsize(parent_type(A))

# `reshape`: specializing it to ensure it returns a `FixedSizeArray`

function Base.reshape(a::FixedSizeArray, size::(NTuple{N,Int} where {N}))
    len = checked_dims(size)
    if length(a) != len
        throw(DimensionMismatch("new shape not consistent with existing array length"))
    end
    new_fixed_size_array(parent(a), size)
end

# `iterate`: the `AbstractArray` fallback doesn't perform well, so add our own methods

function Base.iterate(a::FixedSizeArray)
    iterate(parent(a))
end
function Base.iterate(a::FixedSizeArray, state)
    iterate(parent(a), state)
end

"""
    FixedSizeArrayDefault{T,N}(undef, size::NTuple{N,Int})
    FixedSizeArrayDefault{T,N}(undef, size1::Int, size2::Int, ...)
    FixedSizeArrayDefault{T,N}(array::AbstractArray)

Construct a [`FixedSizeArray`](@ref) with element type `T`, number of dimensions `N`, and the default memory backend (`Vector{T}` on Julia v1.10, `Memory{T}` on Julia v1.11+).
"""
const FixedSizeArrayDefault = FixedSizeArray{T, N, default_underlying_storage_type{T}} where {T, N}
"""
    FixedSizeVectorDefault{T}(undef, size::NTuple{1,Int})
    FixedSizeVectorDefault{T}(undef, size1::Int)
    FixedSizeVectorDefault{T}(array::AbstractVector)

Construct a [`FixedSizeVector`](@ref) with element type `T`, and the default memory backend (`Vector{T}` on Julia v1.10, `Memory{T}` on Julia v1.11+).
"""
const FixedSizeVectorDefault = FixedSizeArrayDefault{T, 1} where {T}
"""
    FixedSizeMatrixDefault{T}(undef, size::NTuple{2,Int})
    FixedSizeMatrixDefault{T}(undef, size1::Int, size2::Int)
    FixedSizeMatrixDefault{T}(array::AbstractMatrix)

Construct a [`FixedSizeMatrix`](@ref) with element type `T`, and the default memory backend (`Vector{T}` on Julia v1.10, `Memory{T}` on Julia v1.11+).
"""
const FixedSizeMatrixDefault = FixedSizeArrayDefault{T, 2} where {T}

# FixedSizeArrays.jl

[`FixedSizeArrays.jl`](https://github.com/JuliaArrays/FixedSizeArrays.jl) is a package for the [Julia programming language](https://julialang.org/) which implements mutable fixed-size arrays ([`FixedSizeArray`](@ref)), which means the length of the array can not change after construction and is amenable to be [constant-propagated](https://en.wikipedia.org/wiki/Constant_folding) at compile-time when possible.

FixedSizeArrays supports the [standard array interfaces](https://docs.julialang.org/en/v1/manual/interfaces/#man-interface-array), so things like broadcasting, matrix multiplication, other linear algebra operations, `similar`, `copyto!` or `map` should just work.

Use the constructors to convert from other array types.
Use `collect_as` from the [Collects.jl](https://github.com/JuliaCollections/Collects.jl) package to convert from arbitrary iterators.

## Comparison with other array types

Here is a quick summary of high-level differences between some different array types:

|                  | Size set at... | Data backend | Growable | Mutable elements |
|------------------|----------------|--------------|----------|------------------|
| `Base.Array`     | runtime        | `Memory`     | ✅       | ✅               |
| `FixedSizeArray` | runtime        | `Memory`     | ❌       | ✅               |
| `MArray`         | compile time   | `Tuple`      | ❌       | ✅               |
| `SArray`         | compile time   | `Tuple`      | ❌       | ❌               |

In the following sections we elaborate on the properties and strengths of the various types.

### `Array` from `Base`

While `Base`'s `Array` is a convenient multi-dimensional container for continuous data, a fixed-size array is what is employed in most linear algebra applications, where the size of [tensors](https://en.wikipedia.org/wiki/Tensor) typically does not change.
Here is a comparison between `Array` and `FixedSizeArray`:

* `Array` is [dynamic](https://en.wikipedia.org/wiki/Dynamic_array) (or growable) which means the size of an `Array` can be changed after construction.  The size of a `FixedSizeArray` cannot be changed;
* the above property of `FixedSizeArray`s enables certain compiler optimizations in some cases where the size of a `FixedSizeArray` is known at compile-time.
  The dynamic property of `Array`s limits the optimization opportunities, which makes `Array`s less likely to be optimized as efficiently as `FixedSizeArray`s.

You can see a showcase of performance/memory advantages of `FixedSizeArray` over `Array` in [this evolving discussion](https://github.com/JuliaArrays/FixedSizeArrays.jl/discussions/62).

### `MArray` from `StaticArrays.jl`

`FixedSizeArray` is an alternative implementation to [`MArray`](https://juliaarrays.github.io/StaticArrays.jl/stable/api/#StaticArraysCore.MArray) from [`StaticArrays.jl`](https://github.com/JuliaArrays/StaticArrays.jl).

Main differences between `FixedSizeArray` and `MArray` are:

* `FixedSizeArray` is based on the `Memory` type introduced in Julia v1.11, `MArray` is backed by tuples, which are not efficient for long arrays (``\gg 100`` elements);
* the size of the array is part of the type parameters of `MArray`, this isn't the case for `FixedSizeArray`, where the size is only a constant field of the data structure.

There are applications where it may be desirable to dispatch on the size of an array, in that case `FixedSizeArray` would not be a good fit and you may consider using `MArray` instead.

`FixedSizeArray` is not a direct replacement for `SArray`: in addition to having the size as part of the type parameters, `SArray` is immutable, instead the elements of a `FixedSizeArray` can be changed at any point.

## What about the other package with same name?

This package is not related to a package with the same name by [`@SimonDanisch`](https://github.com/SimonDanisch/FixedSizeArrays.jl).
That, earlier, package was one of the StaticArrays.jl-like packages in the pre-v1 days of Julia: <https://github.com/SimonDanisch/FixedSizeArrays.jl>.

# Installation

The latest version of `FixedSizeArrays.jl` is available for Julia v1.10 and later releases, and can be installed with [Julia built-in package manager](https://julialang.github.io/Pkg.jl/stable/).
In the Julia REPL, after entering the package manager mode with `]`, run the command

```julia
pkg> update
pkg> add FixedSizeArrays
```

# Reference

## Index
```@index
```

## Public API

```@docs
FixedSizeArrays.FixedSizeArray
FixedSizeVector
FixedSizeMatrix
FixedSizeArrayDefault
FixedSizeVectorDefault
FixedSizeMatrixDefault
Base.parent
BoundsErrorLight
```

## Internal API

This section gathers documentation of internal functionalities of `FixedSizeArrays.jl` which are only of interest to the developers of and contributors to this package.

!!! warning

    The following functionalities are **_not_** part of the public API of the package and should not be relied upon by external packages, as they can be modified or removed at any point without notice.

```@docs
FixedSizeArrays.with_stripped_type_parameters
FixedSizeArrays.with_stripped_type_parameters_unchecked
```

# Usage

## The `FixedSizeArray` type

### Constructors

The basic type provided by this package is [`FixedSizeArray`](@ref).
Its constructor uses a similar syntax to `Base`'s `Array`:

```@repl
using FixedSizeArrays
v = FixedSizeArray{Float64}(undef, 3)
M = FixedSizeArray{Float64}(undef, 2, 2)
```

You can also construct `FixedSizeArray`s from other arrays:

```jldoctest
julia> using FixedSizeArrays

julia> arr = [10 20; 30 14]
2×2 Matrix{Int64}:
 10  20
 30  14

julia> FixedSizeArray(arr)  # construct from an `AbstractArray` value
2×2 FixedSizeArray{Int64, 2, Memory{Int64}}:
 10  20
 30  14

julia> FixedSizeArray{Float64}(arr)  # construct from an `AbstractArray` value while converting element type
2×2 FixedSizeArray{Float64, 2, Memory{Float64}}:
 10.0  20.0
 30.0  14.0
```

To "convert" a wrapper type like `Adjoint` while preserving the wrapper structure, you can use `Adapt`:

```jldoctest
julia> using FixedSizeArrays, Adapt

julia> arr = transpose([10 20; 30 14])
2×2 transpose(::Matrix{Int64}) with eltype Int64:
 10  30
 20  14

julia> adapt(FixedSizeArray, arr)
2×2 transpose(::FixedSizeArray{Int64, 2, Memory{Int64}}) with eltype Int64:
 10  30
 20  14
```

For 1- and 2-dimensional arrays you can use the aliases [`FixedSizeVector`](@ref) and [`FixedSizeMatrix`](@ref), respectively:

```@repl
using FixedSizeArrays
v = FixedSizeVector{Float64}(undef, 2)
M = FixedSizeMatrix{Float64}(undef, 3, 3)
```

### The memory backend

The `FixedSizeArray{T,N,Mem}` type has three parameters:

* `T`: the type of the elements of the array (e.g. `Int64` or `Float64`);
* `N`: the number of dimensions of the array (e.g. 1 for a vector, 2 for a matrix);
* `Mem<:DenseVector{T}`: the memory backend.

!!! note "Implementation details"

    In Julia v1.11+, the default memory backend is the [`Memory{T}`](https://docs.julialang.org/en/v1/base/arrays/#Core.Memory) type.
    Since Julia v1.10 does not have the `Memory` type, to make this package usable also on Julia v1.10 `Vector{T}` is used as memory backend, but many of the memory/performance optimizations enabled by this package will not be available in that version of Julia and in general `FixedSizeArrays.jl` does not provide significant improvements compared to `Base`'s `Array` for that specific version.

To make it easier to refer to the concrete type `FixedSizeArray{T,N,Mem}` with the default memory backend, the following convenient aliases are available:

* [`FixedSizeArrayDefault{T,N}`](@ref);
* [`FixedSizeVectorDefault{T}`](@ref);
* [`FixedSizeMatrixDefault{T}`](@ref).

## The `collect_as` utility

The [array literals syntax](https://docs.julialang.org/en/v1/manual/arrays/#man-array-literals) `[A, B, C, ...]` to construct arrays is limited to `Base`'s `Array` and cannot be extended to custom array types.
The package [Collects.jl](https://github.com/JuliaCollections/Collects.jl) provides a convenient function, `collect_as`, to overcome this limitation and construct `FixedSizeArray`s out of any iterable:

```jldoctest
julia> iter = (i for i ∈ 7:9 if i≠8);

julia> using FixedSizeArrays, Collects

julia> collect_as(FixedSizeArray, iter)  # construct from an arbitrary iterator
2-element FixedSizeArray{Int64, 1, Memory{Int64}}:
 7
 9

julia> collect_as(FixedSizeArray{Float64}, iter)  # construct from an arbitrary iterator while converting element type
2-element FixedSizeArray{Float64, 1, Memory{Float64}}:
 7.0
 9.0

julia> collect_as(FixedSizeVectorDefault, (3.14, -4.2, 2.68))  # construct from a tuple
3-element FixedSizeArray{Float64, 1, Memory{Float64}}:
  3.14
 -4.2
  2.68
```

See the Collects.jl Readme for more information.

## `BoundsErrorLight` exception

To facilitate the [escape analysis](https://en.wikipedia.org/wiki/Escape_analysis) of `FixedSizeArray`s, accessing an out-of-bound index of these arrays raises a [`BoundsErrorLight`](@ref) exception when possible.
This exception type does not store the entire array for reporting the error message, thus enabling more performance optimizations compared to arrays which throw [`BoundsError`](https://docs.julialang.org/en/v1/base/base/#Core.BoundsError) exceptions.

!!! warning "Compatibility of exception raised"

    We do not guarantee to throw either `BoundsError` or `BoundsErrorLight` when accessing an out-of-bound index of a `FixedSizeArray`.
    The exact exception raised may change at any point without breaking the semantic versioning compatibility contract.
